Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -1462,20 +2345,20 @@
                                     // if previous load linked (with the same address), make a transaction
                                     // else, keep in IDLE state and return 1 (no OK)
-                                    if(r_dcache_ll_valid.read() and (r_dcache_ll_addr.read() == (vci_addr_t)dreq.addr)){
-                                        PRINTF("    * <DCACHE> have previous load linked\n");
+                                    if( r_dcache_ll_valid[num_cache][dcache_num_cpu].read() and 
+                                       (r_dcache_ll_addr [num_cache][dcache_num_cpu].read() == (vci_addr_t)_dreq.addr)){
+                                        PRINTF("    * <DCACHE [%d]> have previous load linked\n",num_cache);
                                         
-                                        r_dcache_previous_unc = true;
-
-                                        r_dcache_sc_req   = true;
-
-                                        CACHE_MISS_BUF_REQ_INIT(d);
-
-                                        r_dcache_fsm = DCACHE_SC_WAIT;
+                                        r_dcache_previous_unc[num_cache] = true;
+                                        r_dcache_sc_req      [num_cache] = true;
+
+                                        CACHE_MISS_BUF_REQ_INIT(d,num_cache);
+
+                                        r_dcache_fsm         [num_cache] = DCACHE_SC_WAIT;
                                     } else {
-                                        PRINTF("    * <DCACHE> don't have previous load linked\n");
+                                        PRINTF("    * <DCACHE [%d]> don't have previous load linked\n",num_cache);
                                         
-                                        drsp.valid = true;
-                                        drsp.rdata = 1; // SC rsp NOK
-                                        r_dcache_ll_valid = false;
+                                        _drsp.valid = true;
+                                        _drsp.rdata = 1; // SC rsp NOK
+                                        r_dcache_ll_valid[num_cache][dcache_num_cpu] = false;
                                     }
                                 }
@@ -1486,12 +2369,12 @@
                             case iss_t::XTN_WRITE:
                                 {
-                                    bool drsp_valid = false;
+                                    bool valid = false;
                                     // only DCACHE INVALIDATE and SYNC request are supported
-                                    switch (dreq.addr>>2)
+                                    switch (_dreq.addr>>2)
                                         {
                                         case iss_t::XTN_DCACHE_INVAL : 
                                             {
-                                                drsp_valid = true;
-                                                r_dcache_fsm = DCACHE_INVAL;
+                                                valid = true;
+                                                r_dcache_fsm[num_cache] = DCACHE_INVAL;
                                                 break;
                                             }
@@ -1501,13 +2384,19 @@
                                                 //  * gain : 1 cycle
                                                 //  * cost : can be on the critical path
-                                                if (r_wbuf.empty())
+
+                                                bool empty=true;
+                                                for (uint32_t i=0; i<m_nb_dcache; ++i)
+                                                    empty &= r_wbuf[i]->empty();
+
+                                                if (empty)
                                                     {
-                                                        drsp_valid = true;
-                                                        r_dcache_fsm = DCACHE_IDLE;
+                                                        valid = true;
+                                                        r_dcache_fsm [num_cache] = DCACHE_IDLE;
                                                     }
                                                 else
                                                     {
-                                                        drsp_valid = false;
-                                                        r_dcache_fsm = DCACHE_SYNC;
+                                                        valid = false;
+                                                        r_dcache_fsm [num_cache] = DCACHE_SYNC;
+                                                        r_dcache_sync[num_cache] = true;
                                                     }
                                                 break;
@@ -1516,23 +2405,30 @@
                                             {
                                                 // std::cout << "Warning in VCI_CC_XCACHE_WRAPPER " << name() << std::endl;
-                                                // std::cout << "Unsupported  external access : " << (dreq.addr>>2) << std::endl;
-
-                                                r_dcache_fsm = DCACHE_IDLE;
+                                                // std::cout << "Unsupported  external access : " << (_dreq.addr>>2) << std::endl;
+
+                                                r_dcache_fsm [num_cache] = DCACHE_IDLE;
                                             }
-                                        }//end switch (dreq.addr>>2)
-
-                                    drsp.valid = drsp_valid;
-                                    drsp.rdata = 0;
+                                        }//end switch (_dreq.addr>>2)
+
+                                    _drsp.valid = valid;
+                                    _drsp.rdata = 0;
                                     break;
                                 }
                             case iss_t::DATA_WRITE:
 
-                                if (dcache_cached or not r_dcache_previous_unc.read()) // strongly order to the uncached access
+                                PRINTF("    * <DCACHE [%d]> r_dcache_previous_unc : %d\n",num_cache,r_dcache_previous_unc[num_cache].read());
+
+                                if (dcache_cached or not r_dcache_previous_unc[num_cache].read()) // strongly order to the uncached access
                                 {
-                                    bool drsp_valid;
-
-                                    drsp_valid = r_wbuf.write((addr_40) dreq.addr, dreq.be, dreq.wdata, dcache_cached);
-
-                                    if (drsp_valid)
+                                    bool valid;
+                                    addr_40 addr = _dreq.addr;
+                                    set_num_dcache(addr,num_cache);
+
+                                    // FIXME : virer le set_num_dcache !
+                                    valid = r_wbuf[num_cache]->write(addr, _dreq.be, _dreq.wdata, dcache_cached);
+
+                                    PRINTF("    * <DCACHE [%d]> r_wbuf valid          : %d\n",num_cache,valid);
+
+                                    if (valid)
                                     {
                                         m_cpt_data_write++;
@@ -1540,5 +2436,5 @@
                                         if (not dcache_cached)
                                         {
-                                            r_dcache_previous_unc = true;
+                                            r_dcache_previous_unc[num_cache] = true;
                                             m_cpt_data_write_uncached++;
                                         }
@@ -1546,26 +2442,29 @@
                                             m_cpt_data_write_miss++;
                                         
-                                        if ( dcache_hit) {
-                                            r_dcache_fsm = DCACHE_WRITE_UPDT;
+                                        if (dcache_hit) {
+                                            // update data cache
+                                            r_dcache_fsm[num_cache] = DCACHE_WRITE_UPDT;
                                         } else {
-                                            r_dcache_fsm = DCACHE_IDLE;
+                                            // write accepted
+                                            r_dcache_fsm [num_cache] = DCACHE_IDLE;
                                         }
                                     }
 
-                                    drsp.valid = drsp_valid;
-                                    drsp.rdata = 0;
+                                    _drsp.valid = valid;
+                                    _drsp.rdata = 0;
                                 }
                                 break;
-                        } // end switch dreq.type
-
-                        r_dcache_addr_save      = (addr_40) dreq.addr;
-                        r_dcache_type_save      = dreq.type;
-                        r_dcache_wdata_save     = dreq.wdata;
-                        r_dcache_be_save        = dreq.be;
-                        r_dcache_rdata_save     = dcache_rdata;
-                        r_dcache_cached_save    = dcache_cached;
-                        
-                    } else {    // end if dreq.valid
-                        r_dcache_fsm = DCACHE_IDLE;
+                        } // end switch _dreq.type
+
+                        r_dcache_addr_save   [num_cache] = (addr_40) _dreq.addr;
+                        r_dcache_type_save   [num_cache] = _dreq.type;
+                        r_dcache_wdata_save  [num_cache] = _dreq.wdata;
+                        r_dcache_be_save     [num_cache] = _dreq.be;
+                        r_dcache_rdata_save  [num_cache] = dcache_rdata;
+                        r_dcache_cached_save [num_cache] = dcache_cached;
+                        r_dcache_num_cpu_save[num_cache] = dcache_num_cpu;
+    
+                    } else {    // end if _dreq.valid
+                        r_dcache_fsm [num_cache] = DCACHE_IDLE;
                     }
                     
@@ -1576,10 +2475,10 @@
                 {
                     m_cpt_dcache_data_write++;
-                    data_t mask = vci_param::be2mask(r_dcache_be_save);
-                    data_t wdata = (mask & r_dcache_wdata_save) | (~mask & r_dcache_rdata_save);
-                    vci_addr_t ad = r_dcache_addr_save.read();
-                    r_dcache.write(ad, wdata);
-
-                    r_dcache_fsm = DCACHE_IDLE;
+                    data_t mask = vci_param::be2mask(r_dcache_be_save[num_cache]);
+                    data_t wdata = (mask & r_dcache_wdata_save[num_cache]) | (~mask & r_dcache_rdata_save[num_cache]);
+                    vci_addr_t ad = r_dcache_addr_save[num_cache].read();
+                    r_dcache[num_cache]->write(ad, wdata);
+
+                    r_dcache_fsm [num_cache] = DCACHE_IDLE;
 
                     break;
@@ -1589,17 +2488,20 @@
             case DCACHE_MISS_VICTIM:
                 {
-                    if (not r_dcache_cleanup_req.read())
+                    if (not r_dcache_cleanup_req[num_cache].read())
                      {
                          size_t     way;
                          size_t     set;
-                         vci_addr_t addr = (vci_addr_t) r_dcache_addr_save.read();
+                         vci_addr_t addr = (vci_addr_t) r_dcache_addr_save[num_cache].read();
                          vci_addr_t victim;
+                         bool       victim_val = r_dcache[num_cache]->victim_select(addr, &victim, &way, &set );
                          
-                         r_dcache_cleanup_req  = r_dcache.victim_select(addr, &victim, &way, &set );
-                         r_dcache_cleanup_line = (addr_40) victim;
-                         r_dcache_miss_way     = way;
-                         r_dcache_miss_set     = set;
-                         
-                         r_dcache_fsm = DCACHE_MISS_WAIT;
+                         r_dcache_cleanup_req  [num_cache] = victim_val;
+                         r_dcache_cleanup_line [num_cache] = (addr_40) victim;
+                         r_dcache_miss_way     [num_cache] = way;
+                         r_dcache_miss_set     [num_cache] = set;
+                 
+                         PRINTF("    * <DCACHE [%d]> MISS_VICTIM : Victim %d - %llx (way %d, set %d)\n",num_cache,victim_val, (uint64_t)victim, way, set);
+        
+                         r_dcache_fsm          [num_cache] = DCACHE_MISS_WAIT;
                      }
                     
@@ -1611,44 +2513,29 @@
                 {
 
-                    if ( dreq.valid ) m_cost_data_miss_frz++;
-                    if ( r_tgt_dcache_req.read() ) {   // external request
-                        r_dcache_fsm = DCACHE_CC_CHECK;
-                        r_dcache_fsm_save = r_dcache_fsm;
+                    // if ( _dreq.valid ) m_cost_data_miss_frz++;
+                    if ( r_tgt_dcache_req[num_cache].read() ) {   // external request
+                        r_dcache_fsm      [num_cache] = DCACHE_CC_CHECK;
+                        r_dcache_fsm_save [num_cache] = r_dcache_fsm[num_cache];
                         break;
                     }
 
-                    bool val = CACHE_MISS_BUF_RSP_VAL(d,0);
+                    bool val = CACHE_MISS_BUF_RSP_VAL(d,num_cache,0);
                     if (val)
                     {
-                        // if (not r_dcache_inval_rsp )
-                        //  {
-
                         // Miss read response and no invalidation
-                        if ( r_vci_rsp_data_error )
+                        if (r_vci_rsp_data_error[num_cache])
                         {
-                            r_dcache_fsm = DCACHE_ERROR;
+                            r_dcache_fsm [num_cache] = DCACHE_ERROR;
                         } 
                         else 
                         {
 #if not CC_XCACHE_WRAPPER_SELECT_VICTIM
-                            if (not r_dcache_cleanup_req.read())
+                            if (not r_dcache_cleanup_req[num_cache].read())
 #endif
                             {
-                                r_dcache_update_addr = 0;
-                                r_dcache_fsm         = DCACHE_MISS_UPDT;
+                                r_dcache_update_addr[num_cache] = 0;
+                                r_dcache_fsm        [num_cache] = DCACHE_MISS_UPDT;
                             }
                         }
-                        //  }
-                        // else
-                        // {
-                        //     r_dcache_inval_rsp  = false;
-
-                        //     // Miss read response and invalidation
-                        //     if ( r_vci_rsp_data_error ) {
-                        //         r_dcache_fsm = DCACHE_ERROR;
-                        //     } else {
-                        //         r_dcache_fsm = DCACHE_CC_CLEANUP;
-                        //     }
-                        // }
                     }
                     break;
@@ -1657,16 +2544,16 @@
             case DCACHE_MISS_UPDT:
                 {
-                    size_t     word = r_dcache_update_addr.read();
-                    vci_addr_t addr = (vci_addr_t) r_dcache_addr_save.read();
+                    size_t     word = r_dcache_update_addr[num_cache].read();
+                    vci_addr_t addr = (vci_addr_t) r_dcache_addr_save[num_cache].read();
                     size_t     way  = 0;
                     size_t     set  = 0;
                     
                     // need invalid rsp, don't select a victim
-                    if (not r_dcache_inval_rsp )
+#if CC_XCACHE_WRAPPER_SELECT_VICTIM
+                    way = r_dcache_miss_way[num_cache].read();
+                    set = r_dcache_miss_set[num_cache].read();
+#else
+                    if (not r_dcache_inval_rsp[num_cache] )
                     {
-#if CC_XCACHE_WRAPPER_SELECT_VICTIM
-                        way = r_dcache_miss_way.read();
-                        set = r_dcache_miss_set.read();
-#else
                         // First word : select an victim !
                         if (word == 0)
@@ -1675,50 +2562,55 @@
                         
                             // r_dcache_cleanup_req is false (condition to enter in DCACHE_MISS_UPDT
-                            r_dcache_cleanup_req  = r_dcache.victim_select(addr, &victim, &way, &set );
-                            r_dcache.victim_update_tag(addr, way, set);
-                            r_dcache_cleanup_line = (addr_40) victim;
-
-                            r_dcache_miss_way     = way;
-                            r_dcache_miss_set     = set;
+                            r_dcache_cleanup_req [num_cache]  = r_dcache[num_cache]->victim_select(addr, &victim, &way, &set );
+                            r_dcache[num_cache]->victim_update_tag(addr, way, set);
+                            r_dcache_cleanup_line[num_cache] = (addr_40) victim;
+
+                            r_dcache_miss_way [num_cache] = way;
+                            r_dcache_miss_set [num_cache] = set;
                         }
                         else
                         {
-                            way = r_dcache_miss_way.read();
-                            set = r_dcache_miss_set.read();
+                            way = r_dcache_miss_way[num_cache].read();
+                            set = r_dcache_miss_set[num_cache].read();
                         }
-#endif
-                    }
-
-                    bool val = CACHE_MISS_BUF_RSP_VAL(d,word);
-                    if (val)
+                    }
+#endif
+
+                    PRINTF("    * <DCACHE [%d]> MISS_UPDT : Victim way %d, set %d\n",num_cache, way, set);
+
+                    if (CACHE_MISS_BUF_RSP_VAL(d,num_cache,word))
                     {
                         // m_cpt_dcache_dir_write++;
-                        // if ( ireq.valid ) m_cost_data_miss_frz++;
+                        // if ( _dreq.valid ) m_cost_data_miss_frz++;
 
                         // if need invalid rsp, don't modify the cache, but pop the buf_rsp
-                        if (not r_dcache_inval_rsp )
+                        // (power save)
+                        if (not r_dcache_inval_rsp[num_cache])
                         {
-                            r_dcache.write(way, set, word, CACHE_MISS_BUF_RSP_DATA(d,word));
+                            r_dcache[num_cache]->write(way, set, word, CACHE_MISS_BUF_RSP_DATA(d,num_cache,word));
                             m_cpt_dcache_data_write++;
                         }
 
-                        CACHE_MISS_BUF_RSP_POP(d);
-                        r_dcache_update_addr = ++word;
+                        CACHE_MISS_BUF_RSP_POP(d,num_cache);
+                        r_dcache_update_addr[num_cache] = ++word;
                             
                         // if last word, finish the update
                         if (word >= m_dcache_words)
                         {
+#if CC_XCACHE_WRAPPER_SELECT_VICTIM
+                            // in all case (inval_rsp or not), update the victim tag
+                            // because victim is already cleanup
+                            r_dcache[num_cache]->victim_update_tag(addr, way, set);
+#endif
+
                             // Last word : if previous invalid_rsp, can cleanup, else update the TAG
-                            if (r_dcache_inval_rsp)
+                            if (r_dcache_inval_rsp[num_cache])
                             {
-                                r_dcache_inval_rsp  = false;
-                                r_dcache_fsm = DCACHE_CC_CLEANUP;
+                                r_dcache_inval_rsp[num_cache] = false;
+                                r_dcache_fsm      [num_cache] = DCACHE_CC_CLEANUP;
                             }
                             else
                             {
-#if CC_XCACHE_WRAPPER_SELECT_VICTIM
-                                r_dcache.victim_update_tag(addr, way, set);
-#endif
-                                r_dcache_fsm = DCACHE_IDLE;
+                                r_dcache_fsm [num_cache] = DCACHE_IDLE;
                             }
                         }
@@ -1730,30 +2622,31 @@
             case DCACHE_UNC_WAIT:
                 {
-                    if ( dreq.valid ) m_cost_unc_read_frz++;
-                    if ( r_tgt_dcache_req ) {   // external request
-                        r_dcache_fsm = DCACHE_CC_CHECK;
-                        r_dcache_fsm_save = r_dcache_fsm;
+                    // if ( _dreq.valid ) m_cost_unc_read_frz++;
+                    if ( r_tgt_dcache_req[num_cache] ) {   // external request
+                        r_dcache_fsm     [num_cache] = DCACHE_CC_CHECK;
+                        r_dcache_fsm_save[num_cache] = r_dcache_fsm[num_cache];
                         break;
                     } 
 
-                    bool ok = CACHE_MISS_BUF_RSP_VAL(d,0);
+                    bool ok = CACHE_MISS_BUF_RSP_VAL(d,num_cache,0);
 
                     if (ok) {
-                        if ( r_vci_rsp_data_error ) {
-                            r_dcache_fsm = DCACHE_ERROR;
+                        if (r_vci_rsp_data_error[num_cache]) {
+                            r_dcache_fsm[num_cache] = DCACHE_ERROR;
                         } else {
-                            data_t rdata = CACHE_MISS_BUF_RSP_DATA(d,0);
-                            CACHE_MISS_BUF_RSP_POP(d);
-
-                            if(dreq.type == iss_t::DATA_LL){
-                                PRINTF("    * <DCACHE> ll_valid = true\n");
-
-                                r_dcache_ll_valid = true;
-                                r_dcache_ll_data = rdata;
-                                r_dcache_ll_addr = (vci_addr_t) dreq.addr;
+                            data_t rdata = CACHE_MISS_BUF_RSP_DATA(d,num_cache,0);
+                            CACHE_MISS_BUF_RSP_POP(d,num_cache);
+
+                            if(_dreq.type == iss_t::DATA_LL){
+                                PRINTF("    * <DCACHE [%d]> ll_valid = true\n",num_cache);
+
+                                r_dcache_ll_valid  [num_cache][r_dcache_num_cpu_save[num_cache]] = true;
+                                r_dcache_ll_data   [num_cache][r_dcache_num_cpu_save[num_cache]] = rdata;
+                                r_dcache_ll_addr   [num_cache][r_dcache_num_cpu_save[num_cache]] = (vci_addr_t) _dreq.addr;
                             }
-                            r_dcache_fsm = DCACHE_IDLE;
-                            drsp.valid = true;
-                            drsp.rdata = rdata;
+                            r_dcache_fsm [num_cache] = DCACHE_IDLE;
+
+                            _drsp.valid = true;
+                            _drsp.rdata = rdata;
                         }
                     }
@@ -1763,22 +2656,23 @@
             case DCACHE_SC_WAIT:
                 {
-                    if ( dreq.valid ) m_cost_unc_read_frz++;
-                    if ( r_tgt_dcache_req ) {   // external request
-                        r_dcache_fsm = DCACHE_CC_CHECK;
-                        r_dcache_fsm_save = r_dcache_fsm;
+                    // if ( _dreq.valid ) m_cost_unc_read_frz++;
+                    if ( r_tgt_dcache_req[num_cache] ) {   // external request
+                        r_dcache_fsm      [num_cache] = DCACHE_CC_CHECK;
+                        r_dcache_fsm_save [num_cache] = r_dcache_fsm [num_cache];
                         break;
                     } 
 
-                    bool ok = CACHE_MISS_BUF_RSP_VAL(d,0);
+                    bool ok = CACHE_MISS_BUF_RSP_VAL(d,num_cache,0);
 
                     if (ok) {
-                        if ( r_vci_rsp_data_error ) {
-                            r_dcache_fsm = DCACHE_ERROR;
+                        if (r_vci_rsp_data_error[num_cache]) {
+                            r_dcache_fsm [num_cache] = DCACHE_ERROR;
                         } else {
-                            r_dcache_fsm = DCACHE_IDLE;
-                            drsp.valid = true;
-                            drsp.rdata = CACHE_MISS_BUF_RSP_DATA(d,0);
-                            CACHE_MISS_BUF_RSP_POP(d);
-                            r_dcache_ll_valid = false;
+                            r_dcache_fsm [num_cache] = DCACHE_IDLE;
+
+                            _drsp.valid = true;
+                            _drsp.rdata = CACHE_MISS_BUF_RSP_DATA(d,num_cache,0);
+                            CACHE_MISS_BUF_RSP_POP(d,num_cache);
+                            r_dcache_ll_valid [num_cache][r_dcache_num_cpu_save[num_cache]] = false;
                         }
                     }
@@ -1789,8 +2683,9 @@
             case DCACHE_ERROR:
                 {
-                    r_dcache_fsm = DCACHE_IDLE;
-                    r_vci_rsp_data_error = false;
-                    drsp.error = true;
-                    drsp.valid = true;
+                    r_dcache_fsm        [num_cache] = DCACHE_IDLE;
+
+                    r_vci_rsp_data_error[num_cache] = false;
+                    _drsp.error = true;
+                    _drsp.valid = true;
                     break;
                 }
@@ -1798,16 +2693,16 @@
             case DCACHE_INVAL:
                 {
-                    if ( r_tgt_dcache_req.read() ) {   // external request
-                        r_dcache_fsm = DCACHE_CC_CHECK;
-                        r_dcache_fsm_save = r_dcache_fsm;
+                    if ( r_tgt_dcache_req[num_cache].read() ) {   // external request
+                        r_dcache_fsm      [num_cache] = DCACHE_CC_CHECK;
+                        r_dcache_fsm_save [num_cache] = r_dcache_fsm [num_cache];
                         break;
                     }
-                    if( not r_dcache_cleanup_req.read() ){
+                    if( not r_dcache_cleanup_req [num_cache].read() ){
                         m_cpt_dcache_dir_read += m_dcache_ways;
-                        vci_addr_t  ad  = r_dcache_addr_save.read();
-                        r_dcache_cleanup_req = r_dcache.inval(ad);
-                        r_dcache_cleanup_line = r_dcache_addr_save.read() >> m_dcache_words_shift;
-
-                        r_dcache_fsm = DCACHE_IDLE;
+                        vci_addr_t  ad  = r_dcache_addr_save [num_cache].read();
+                        r_dcache_cleanup_req  [num_cache] = r_dcache[num_cache]->inval(ad);
+                        r_dcache_cleanup_line [num_cache] = r_dcache_addr_save [num_cache].read() >> m_dcache_words_shift;
+
+                        r_dcache_fsm          [num_cache] = DCACHE_IDLE;
                     }
                     break;
@@ -1815,15 +2710,20 @@
             case DCACHE_SYNC :
                 {
-                    if ( r_tgt_dcache_req ) {   // external request
-                        r_dcache_fsm = DCACHE_CC_CHECK;
-                        r_dcache_fsm_save = r_dcache_fsm;
+                    if ( r_tgt_dcache_req[num_cache] ) {   // external request
+                        r_dcache_fsm     [num_cache] = DCACHE_CC_CHECK;
+                        r_dcache_fsm_save[num_cache] = r_dcache_fsm[num_cache];
                         break;
                     } 
 
-                    if (r_wbuf.empty())
-                        {
-                            drsp.valid = true; // end, can accept the sync request
-                            r_dcache_fsm = DCACHE_IDLE;
-                        }
+                    bool empty=true;
+                    for (uint32_t i=0; i<m_nb_dcache; ++i)
+                        empty &= r_wbuf[i]->empty();
+                    
+                    if (empty)
+                    {
+                        _drsp.valid = true; // end, can accept the sync request
+                        r_dcache_fsm [num_cache] = DCACHE_IDLE;
+                        r_dcache_sync[num_cache] = false;
+                    }
                     break;
                 }
@@ -1831,19 +2731,27 @@
             case DCACHE_CC_CHECK:   // read directory in case of invalidate or update request
                 {
-                    addr_40  ad          = r_tgt_addr;
+                    addr_40  ad          = r_tgt_daddr;
                     data_t  dcache_rdata = 0;
 
-                    if((r_dcache_fsm_save == DCACHE_MISS_WAIT) and 
-                            ( (r_dcache_addr_save.read() & ~((m_dcache_words<<2)-1)) == (ad & ~((m_dcache_words<<2)-1)))) {
-                        r_dcache_inval_rsp = true;
-                        r_tgt_dcache_req = false;
+                    PRINTF("    * <DCACHE [%d]> CC_CHECK\n",num_cache);
+
+                    if((r_dcache_fsm_save[num_cache] == DCACHE_MISS_WAIT) and 
+                       ((r_dcache_addr_save[num_cache].read() & ~((m_dcache_words<<2)-1)) == (ad & ~((m_dcache_words<<2)-1)))) {
+                        PRINTF("    * <DCACHE [%d]> have request, need inval rsp\n",num_cache);
+
+                        r_dcache_inval_rsp[num_cache] = true;
+                        r_tgt_dcache_req  [num_cache] = false;
                         if(r_tgt_update){    // Also send a cleanup and answer
-                            r_tgt_dcache_rsp     = true;
+                            PRINTF("    * <DCACHE [%d]> send a cleanup and answer\n",num_cache);
+                            r_tgt_dcache_rsp[num_cache]     = true;
                         } else {            // Also send a cleanup but don't answer
-                            r_tgt_dcache_rsp     = false;
+                            PRINTF("    * <DCACHE [%d]> send a cleanup and but don't answer\n",num_cache);
+                            r_tgt_dcache_rsp[num_cache]     = false;
                         }
-                        r_dcache_fsm = r_dcache_fsm_save;
+                        r_dcache_fsm[num_cache] = r_dcache_fsm_save[num_cache];
                     } else {
-                        bool    dcache_hit   = r_dcache.read(ad, &dcache_rdata);
+                        bool    dcache_hit   = r_dcache[num_cache]->read(ad, &dcache_rdata);
+
+                        PRINTF("    * <DCACHE [%d]> have no request, hit cache : %d, update : %d\n",num_cache,dcache_hit,(uint32_t)r_tgt_update);
 
                         m_cpt_dcache_data_read += m_dcache_ways;
@@ -1860,5 +2768,5 @@
                             data_t   rdata = 0;
 
-                            r_dcache.read(ad+word*4,&rdata);
+                            r_dcache[num_cache]->read(ad+word*4,&rdata);
                             
                             r_tgt_buf[word] = (mask & r_tgt_buf[word]) | (~mask & rdata);
@@ -1873,5 +2781,5 @@
                             if (word==m_dcache_words)
                             {
-                                r_dcache_fsm = DCACHE_CC_UPDT;
+                                r_dcache_fsm[num_cache] = DCACHE_CC_UPDT;
 #if CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE_OPT
                                 for (word=0; word<m_dcache_words; ++word)
